/*
 * 쐬: 2005/09/07
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */

/**
 * @author Naoto Shinohara
 *
 * TODO ̐ꂽ^Rg̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */


package strategy;
import java.util.*;

import strategy.Order;

//NX̐錾Ep

public class T06_Shinohara_WmaRsiStrategy extends Strategy {
//l
	
	private Random random;
	
	private final int maxPosition = 1000;
	private final int nominalPrice = 3000;
	private final int spread = 250;
	private final double edgeL = 0.55;
	private final double edgeH = 0.45;
	private final double edgeLL = 0.35;
	private final double edgeHH = 0.65;
	
//_I[_[
	public  T06_Shinohara_WmaRsiStrategy(int seed){
		random = new Random(seed);
	}
	
	public Order getOrder(int[] spotPrice, int[] futurePrice, int pos,
							long money, int restDay){
		Order order = new Order();
		
		int latestSpotPrice = spotPrice[119];
		int latestFuturePrice = futurePrice[59];
		
		
//LZ
		
		if((latestSpotPrice<=0) || (latestFuturePrice<0)){
			order.buysell = order.NONE;
			return order;
		}
		
//WMǍvZ
//WMA[0] = laest, WMA[1] = previous, WMA[2] = three count ago
		
		double WMA[] = new double[3];
		
	for(int i = 0; i < 3; i++){
		
		 WMA[i] = ((double)futurePrice[59-i]*5 + futurePrice[58-i]*4 
		               + futurePrice[57-i]*3 + futurePrice[56-i]*2
					   + futurePrice[55-i]*1) / 15;
	}	
		


//RSǏvZ
//RSI[2] = laest, RSI[1] = previous, RSI[2] = three count ago
		
		double RSI[] = new double[3];
		int sumP = 0;
		int sumN = 0;
		
		
		for(int i = 0; i < 3; i++){
			for(int j = 59 - i; j >= 44 - i; j--){
				int temp = futurePrice[j] - futurePrice[j-1];
			
				if(temp >= 0){
					sumP += temp;
				}
				else{
				sumN += temp;
				}
			}
		
			 RSI[i] = (double)sumP / (double)(sumP - sumN);
		}
		
		
		
		
		
//f
		if(latestFuturePrice - latestSpotPrice > spread){
			order.buysell = Order.SELL;
		}
		else if(latestSpotPrice - latestFuturePrice > spread){
			order.buysell = Order.BUY;
		}
		else if((WMA[2] < WMA[1]) && (WMA[1]<= WMA[0])){
			    if((RSI[2] > RSI[1]) && (RSI[1] > RSI[0])
			 		  && (latestFuturePrice > latestSpotPrice)){
				     order.buysell = Order.SELL;
			     }
			     else if((RSI[2] > edgeH) && (RSI[1] > edgeH) && (RSI[0] < edgeH)){
				     order.buysell = Order.SELL;
			     }
			
			     else{
				     order.buysell = Order.NONE;
				       return order;
			     }
		}   
		
		
		else if((WMA[2] > WMA[1])  && (WMA[1] > WMA[0])){
			if((RSI[2] < RSI[1]) && (RSI[1] < RSI[0])
			 		&& (latestFuturePrice < latestSpotPrice)){
				order.buysell = Order.BUY;
			}
			else if((RSI[2] < edgeL) && (RSI[1] < edgeL) && RSI[0] > edgeL){
				order.buysell = Order.BUY;
			}
			else{
				order.buysell = Order.NONE;
				return order;
			}
		}
		else if((RSI[1] > edgeHH) && (RSI[0] < edgeHH)){
			order.buysell = Order.SELL;
		}
		else if((RSI[1] < edgeLL) && (RSI[0] > edgeLL)){
			order.buysell = Order.BUY;
				}
		else{
			order.buysell = Order.NONE;
		}
		
		
//|WVǗ
		
		if(order.buysell == Order.BUY){
			if(pos > maxPosition){
				order.buysell = Order.NONE;
				return order;
			}
		}
		else if(order.buysell == Order.SELL){
			if (pos <- maxPosition){
				order.buysell = Order.NONE;
				return order;
			}
		}
		
		
		
//i
		
		if(order.buysell == Order.BUY){
			order.price = latestFuturePrice + 100;
		}
		else if(order.buysell == Order.SELL){
			order.price = latestFuturePrice - 100;
		}
		
		
		
		
//
		if(latestFuturePrice - latestSpotPrice > Math.abs(spread)){
			order.quant = 300;
		}
		
		else{
			order.quant = 180;
		}
		
		
		
		
//Message
		
		 message(
		 Order.buySellToString(order.buysell) + 
		 ",price = " + order.price + 
		 ",volume = " + order.quant + 
		 "(RSI[0] = " + RSI[0] +
		 ")"
		);
		return order;
		
		
								 
	}
}
