/*
MarketMaker_MM1
Copyright (c) 2004 NAKAJIMA Yoshihiro
*/

package strategy;
import java.util.*;
import java.io.*;

public class MarketMakerStrategy_MM1 extends Strategy {
  private Random random;

  private final double a=0.0001; // XvbhvŽW (3֐̌Wj
  private final double b=0.01;   // |WV[̎̃Xvbh
  private final double c=a/2.0;  // dsus̑xp[^
  /* Constructor for Agent Initialization */
  public MarketMakerStrategy_MM1(int seed) {
    random = new Random(seed);
  }
  
  public void action( int[] spotPrices, int[] futurePrices, int pos, long money, int restDay ) {
    Order order = new Order(); 
    int prevPrice = getLatestPrice(futurePrices );
    if(prevPrice<0){
      prevPrice = getLatestPrice(spotPrices );
    }

    double x=(double)pos;
    double lowerSpread=0.01;
    double bidPrice=(1-lowerSpread)*prevPrice;
    
    double upperSpread=0.01;
    double askPrice=(1+upperSpread)*prevPrice;

    order.quant=1; // MḾAxɈꖇ̒

    order.price=(int)bidPrice;
    if(order.price>0){
      order.buysell=Order.BUY;
      orderRequest(order);
    }      

    order.price=(int)askPrice;    
    if(order.price>0){
      order.buysell=Order.SELL;
      orderRequest(order);
    }

  } // end of action
}
