
package strategy;

import java.util.*;


public class Trend_swiftStrategy extends Strategy {

    private Random random;
    private final int maxPosition = 230; 
    private int priceEdge = 40;
    private int spreadEdge = 10;  
    private boolean spotTrendFlag;
    private boolean spotATrendFlag;
    private boolean spreadFlag;
    int BuySell = 0;  
    int price = 0;
    int quant = 0;

    public Trend_swiftStrategy(int seed) {
	random = new Random(seed);
	
    }
    
    
    public Order getOrder(int[] spotPrices, int[] futurePrices, int pos, 
			  											long money, int restDay){
    				Order order = new Order();
	                
//ʃuO
	                spotTrendFlag = spotPrices[119] > spotPrices[118];
	                spotATrendFlag = spotPrices[119] < spotPrices[118];
	                
	            	int latestSpotPrice = spotPrices[119];
	            	int latestFuturePrice = futurePrices[59];
	            	int spotSpread=latestSpotPrice - latestFuturePrice;
	            	int spreadPrice = latestSpotPrice - latestFuturePrice;
	         
//
	            	setBuySell(order, spotTrendFlag, spotATrendFlag, spreadPrice,
	            			                        spreadEdge,latestFuturePrice);

//
	                double beta1 = 2.8;
	        		double beta2 = 0.1;
	                int preQuant = (int)(Math.abs(spotSpread)*beta1) - (int)(beta2*pos);
	                quant = Math.min(preQuant, 80);
	               	             
// LZ 
	            	if( BuySell == 2 ) {
	            	    if( pos > maxPosition ) {
	            	    	order.buysell = Order.NONE;
	            		return order;
	            	    }
	            	} else if ( BuySell == 1 ) {
	            	    if( pos < -maxPosition ) {
	            		order.buysell = Order.NONE;
	            		return order;
	            	    }
	            	}

//      
		order.buysell = BuySell;        
		order.quant = quant;
		order.price = price;


        return order;   
    }
    
    
//f\bh  
    public void setBuySell(Order order, boolean spotTrendFlag, boolean spotATrendFlag,
    		                   int spreadPrice,int spreadEdge,int latestFuturePrice){
 
        if((spotTrendFlag) && (spreadPrice > spreadEdge)){
        	BuySell = 2;
        	price = latestFuturePrice + priceEdge; 
        	
        }else if ((spotATrendFlag) && (spreadPrice < -spreadEdge)){
        	BuySell = 1;
        	price = latestFuturePrice - priceEdge;
        
        }else{
        	BuySell = 0;
			
        }       
    }
}
