package strategy;

import java.util.*;
import strategy.*;

public class A0027757aStrategy extends Strategy {

	/** ĩ̕ftHgl */
	public static final int DEFAULT_WIDTH_OF_PRICE = 20;
	/** ʂ̍ől̃ftHgl */
	public static final int DEFAULT_MAX_QUANT = 50;
	/** ʂ̍ŏl̃ftHgl */
	public static final int DEFAULT_MIN_QUANT = 10;
	/** |WV̍ől̃ftHgl */
	public static final int DEFAULT_MAX_POSITION = 300;
	/** 瓾SẲi񂪖̂ƂɎgĩftHgl */
	public static final int DEFAULT_NOMINAL_PRICE = 3000;
	/**  */
	private Random fRandom;
	/** i̕ */
	private int fWidthOfPrice = DEFAULT_WIDTH_OF_PRICE;
	/** ʂ̍ől */
	private int fMaxQuant = DEFAULT_MAX_QUANT;
	/** ʂ̍ŏl */
	private int fMinQuant = DEFAULT_MIN_QUANT;
	/** |WV̍ől */
	private int fMaxPosition = DEFAULT_MAX_POSITION;
	/** 瓾SẲi񂪖̂ƂɎgi */
	private int fNominalPrice = DEFAULT_NOMINAL_PRICE;

//tB{ib`: 1 2 3 5 8 13


//ς݂true
	private boolean initializeFlag = false;
//dayǐߐ
	private int allDay;
//i
	private double[] mySpotPrices;
//敨i
	private double[] myFuturePrices;
	private double[] myAvgPrices;
	private double[] myAvgPrices2;

//̑x
	private double[] myAvgSpeed;

//ww͒ǂ
	private boolean isExchanging = false;

//wڕW
	private int targetPosition;
	private int targetPrice;
	private int lastPosition;
	private int lastPrice;

//Ԑ
	private int lastExchangeDay = 0;
	private int noExchangeDay = 0;
	private int exchangeDayLeft = 0;

	private boolean increacingFlag;

	private int today;
	private int today_i;

//constructor
	public A0027757aStrategy(int seed) {
		fRandom = new Random(seed);
	}


//񂹑OɌĂ΂郁\bhBsB
//restDay͍܂߂c̐ߐB240, 239, 238...
	public void action(int[] spotPrices, int[] futurePrices, int pos, long money, int restDay) {
		if (! initializeFlag) {
			allDay = restDay;
			InitializeArrays();

			initializeFlag = true;
		}

		today_i = allDay - restDay;
		today = today_i + 1;
		AnalyzePrices(spotPrices, futurePrices, today_i);

		if (today <= 3) {
			return;
		}
		if (today == 5) {
			if (myAvgSpeed[today_i] > 0) {
				increacingFlag = true;
			} else {
				increacingFlag = false;
			}
		}


//
System.out.println("# " + pos);
		if (isExchanging) {
			if (pos != targetPosition) {
				if (exchangeDayLeft > 0) {
System.out.println("#̏");

					SetPosition(targetPosition); //ꉞ
				} else {
System.out.println("#s");

					isExchanging = false;
					targetPosition = pos;
				}
			} else {
System.out.println("#");
				isExchanging = false;
			}
		}


		if (increacingFlag) {
			if (myAvgSpeed[today_i - 1] > 0 && myAvgSpeed[today_i] < 0) {
				increacingFlag = false;

				if (myFuturePrices[today_i] - myAvgPrices2[today_i] > 8) {
					SetPosition(-200);
				}

				System.out.println("# V");
			}
		} else {
			if (myAvgSpeed[today_i - 1] < 0 && myAvgSpeed[today_i] > 0) {
				increacingFlag = true;

				if (myAvgPrices2[today_i] - myFuturePrices[today_i] > 8) {
					SetPosition(200);
				}

				System.out.println("# ");
			}
		}

		doOrder(pos);
	}

	private void SetPosition(int target) {
		targetPosition = target;
		lastExchangeDay = today;
		isExchanging = true;
		exchangeDayLeft = 3;
	}

	private void doOrder(int nowPosition) {
		if (nowPosition == targetPosition) {
			return;
		}

System.out.println("#posݒ " + nowPosition + "=>" + targetPosition);

		int restPos = targetPosition - nowPosition;
		if (restPos > 0) {
			BuyOrder(-1, restPos);
		} else if (restPos < 0) {
			SellOrder(-1, -restPos);
		}
	}

	private void SellOrder(int price, int quant) {
		Order order = new Order();

		order.buysell = Order.SELL;
		if (price == -1) {
			order.price = (int)(myFuturePrices[today_i] - 10);
		} else {
			order.price = price;
		}
		order.quant = quant;

		System.out.println("#" + Order.buySellToString(order.buysell)
			+ ", price = " + order.price
			+ ", volume = " + order.quant
			+ " )");

		orderRequest(order);
	}

	private void BuyOrder(int price, int quant) {
		Order order = new Order();

		order.buysell = Order.BUY;
		if (price == -1) {
			order.price = (int)(myFuturePrices[today_i] + 10);
		} else {
			order.price = price;
		}
		order.quant = quant;

		System.out.println("#" + Order.buySellToString(order.buysell)
			+ ", price = " + order.price
			+ ", volume = " + order.quant
			+ " )");

		orderRequest(order);
	}

	private void AnalyzePrices(int[] spotPrices, int[] futurePrices, int i) {
		mySpotPrices[i] = getLatestPrice(spotPrices);
		myFuturePrices[i] = getLatestPrice(futurePrices);

//2ڂ-1o₷̂ő΍B
		if (myFuturePrices[i] <= 0) {
			myFuturePrices[i] = mySpotPrices[i];
		}


//calculate myAvgPrices
		{
			double[] weightTable = {100, 100, 75, 50, 20, 10, 5, 5};

			if (i == 0) {
				myAvgPrices[i] = myFuturePrices[i];
			} else if (i < weightTable.length) {
				int tmp = 0;

				for (int k = 0; k <= i; k++) {
					tmp += myFuturePrices[i - k] * weightTable[k];
				}

				myAvgPrices[i] = tmp / getSum(weightTable, i + 1);
			} else {
				int tmp = 0;

				for (int k = 0; k < weightTable.length; k++) {
					tmp += myFuturePrices[i - k] * weightTable[k];
				}

				myAvgPrices[i] = tmp / getSum(weightTable, weightTable.length);
			}
		}

		{
			int num = 20;

			if (i == 0) {
				myAvgPrices2[i] = myFuturePrices[i];
			} else if (i < num) {
				myAvgPrices2[i] = myAvgPrices2[i - 1] + myFuturePrices[i] / num - myAvgPrices2[0] / num;
			} else {
				myAvgPrices2[i] = myAvgPrices2[i - 1] + myFuturePrices[i] / num - myAvgPrices2[i - num] / num;
			}
		}


//calculate myAvgSpeed
		{
			double currentSpeed = myAvgPrices[i] - myAvgPrices[i - 1];
			int num = 2;

			if (i == 0) {
				myAvgSpeed[i] = 0;
			} else if (i < num) {
				myAvgSpeed[i] = myAvgSpeed[i - 1] + currentSpeed / num - myAvgSpeed[0] / num;
			} else {
				myAvgSpeed[i] = myAvgSpeed[i - 1] + currentSpeed / num - myAvgSpeed[i - num] / num;
			}
		}

		String speedStr = "";
		if (myAvgSpeed[i] > 0) {
			for (int k = 0; k < myAvgSpeed[i] * 2; k++) {
				speedStr += "#";
			}
		} else {
			for (int k = 0; k < -myAvgSpeed[i] * 2; k++) {
				speedStr += "O";
			}
		}

		System.out.println(i + "	" + myAvgPrices[i]);
		System.out.println("#" + i + "	" + speedStr);
	}

	private void InitializeArrays() {
		mySpotPrices = new double[allDay];
		myFuturePrices = new double[allDay];
		myAvgPrices = new double[allDay];
		myAvgPrices2 = new double[allDay];
		myAvgSpeed = new double[allDay];
	}

	private double abs (double n) {
		if (n > 0) {
			return n;
		} else {
			return -n;
		}
	}

	private double getSum(double[] array, int length) {
		double sum = 0;

		for (int i = 0; i < length; i++) {
			sum += array[i];
		}

		return sum;
	}

	private double getAverage(double[] array) {
		return getSum(array, array.length) / array.length;
	}


	public void setParameters(String[] args) {
		super.setParameters(args);

		for (int i = 0; i < args.length; ++i) {
			StringTokenizer st = new StringTokenizer(args[i], "= ");
			String key = st.nextToken();
			String value = st.nextToken();
			// System.err.println(key + "=" + value);
			if (key.equals("WidthOfPrice")) {
				fWidthOfPrice = Integer.parseInt(value);
			} else if (key.equals("MinQuant")) {
				fMinQuant = Integer.parseInt(value);
			} else if (key.equals("MaxQuant")) {
				fMaxQuant = Integer.parseInt(value);
			} else if (key.equals("MaxPosition")) {
				fMaxPosition = Integer.parseInt(value);
			} else {
				System.err.println("Unknown parameter:" + key
									   + " in RandomStrategy.setParameters");
				System.exit(5);
			}
		}
	}
}

