package strategy;

import java.util.*;

/**
 * 
 * @author A.Nakamura@
 *
 * NTƂ헪@U-Mart2005p
 * iep[^[L̂ɂAFlł낤̂傢Oɐݒ肷B
 * @tB[hlȂǎQƁBƂ͖\\zďɕ̒ĂBj
 */

public class Nakamura_spreadStrategy extends Strategy {

	private Random random;
	private int spreadStartIndex = 22;
	private int orderQuant = 25;
	private int maxPosition = 400;
	private int addPrice = 200; 

	public Nakamura_spreadStrategy(int seed) {
		random = new Random(seed);
	}
    public void action( int[] spotPrices, int[] futurePrices, int pos, long money, int restDay ) {
    	//ȉ3̒ɓɏoB
    	Order order = new Order();         //@ʏ̃TƂ
    	Order maxPriceOrder = new Order(); //A\҂̃TƂ
    	Order minPriceOrder = new Order(); //B\҂̃TƂ
    	
        order = getOrder(spotPrices, futurePrices, pos, money, restDay);
        maxPriceOrder = getMaxPriceOrder(spotPrices);
        minPriceOrder = getMinPriceOrder(spotPrices);
        
        //SVMPiU-Mart̒ʐMvgRjłorderRequest\bhɂăT[o[֒B
    	orderRequest(order); 
    	orderRequest(maxPriceOrder);
    	orderRequest(minPriceOrder);
    }
    //@ʏ̃TƂ̒
	public Order getOrder(int[] spotPrices, int[] futurePrices, int pos,long money, int restDay) {

				Order order = new Order();
				setOrderBuySell(order, futurePrices, spotPrices, pos);//f
				setOrderQuant(order, spotPrices, futurePrices, pos);  //
				setOrderPrice(order, futurePrices, spotPrices);       //wl
				setMaxPosition(order, futurePrices, pos) ;            //|WV̐
				return order;
	}


	public void setOrderBuySell(Order order, int[] futurePrices,int[] spotPrices, int pos) {
		int latestFuturePrice = futurePrices[59];//敨ŐVi
		int latestSpotPrice = spotPrices[119];   //ŐVi
		
		//i-1ɂȂ͑OiŖ߂B
		if(latestFuturePrice < 0){
			latestFuturePrice = futurePrices[futurePrices.length-2];
		}else if(latestSpotPrice < 0){
			latestSpotPrice = spotPrices[spotPrices.length-2];
		}
		int spreadPrice = latestSpotPrice - latestFuturePrice; //T
		//f
		if((latestSpotPrice > 0) || (latestFuturePrice > 0)){
			if(spreadPrice > spreadStartIndex){
				order.buysell = 2;
			}else if(spreadPrice < -spreadStartIndex){
				order.buysell = 1;
			}else{
				order.buysell = 0;
			}
		}else{
			order.buysell = 0;
		}
	}
	//T̐Βl򂳂ĒʂB
	public void setOrderQuant(Order order,int[] spotPrices, int[] futurePrices, int pos) {
		int spread = Math.abs(spotPrices[119] - futurePrices[59]);
  		if(spread > spreadStartIndex*6){
  			order.quant = orderQuant*6;
  		}else if(spread > spreadStartIndex*5){
  			order.quant = orderQuant*5;
  		}else if(spread > spreadStartIndex*4){
  			order.quant = orderQuant*4;
  		}else if(spread > spreadStartIndex*3){
  			order.quant = orderQuant*3;
  		}else if(spread > spreadStartIndex*2){
  			order.quant = orderQuant*2;
  		}else if(spread > spreadStartIndex){
  			order.quant = orderQuant;
  		}
	}
    //Ɛ敨̒ԉiwl̒iƂB
	public void setOrderPrice(Order order, int[] futurePrices, int[] spotPrices) {
		if (order.buysell == 2) {
			order.price = futurePrices[59] + (int)(Math.abs((futurePrices[59] - spotPrices[119]))/2);
		} else if (order.buysell == 1) {
			order.price = futurePrices[59] - (int)(Math.abs((futurePrices[59] - spotPrices[119]))/2);
		}
	}
	//|WV̏B@order݂̂ɐB
	public Order setMaxPosition(Order order, int[] futurePrices, int pos){
		if( order.buysell == Order.BUY ) {
		    if( pos > maxPosition ) {
			order.buysell = Order.NONE;
		    }
		} else if ( order.buysell == Order.SELL ) {
		    if( pos < -maxPosition ) {
			order.buysell = Order.NONE;
		    }
		}return order;
	}
	
	//A\҂B{addPricêƂő҂\B
	public Order getMaxPriceOrder(int[] spotPrices){
		Order order = new Order();
		order.buysell = 1;
		order.quant = 400;
		order.price = (int)(spotPrices[119] + addPrice);
		return order;
	}
	//B\҂Blɉő҂\B
	public Order getMinPriceOrder(int[] spotPrices){
		Order order = new Order();
		order.buysell = 2;
		order.quant = 400;
		order.price = (int)(spotPrices[119] - addPrice);
		return order;
	}
}