/*
MarketMaker_MR
Copyright (c) 2004 NAKAJIMA Yoshihiro
Market Maker ƑΏƎsׂ̃G[WFg
_ɁA肩̒oB
*/

package strategy;
import java.util.*;
import java.io.*;

public class T01_MarketMakerStrategy_MR extends Strategy {
  private Random random;

  private final double a=0.0001; // XvbhvŽW (3֐̌Wj
  private final double b=0.01;   // |WV[̎̃Xvbh
  private final double c=a/2.0;  // dsus̑xp[^

  private double ContractTimes=0;
  private double SFSpread=0;
  
  /* Constructor for Agent Initialization */
  public T01_MarketMakerStrategy_MR(int seed) {
    random = new Random(seed);
  }

  public void action( int[] spotPrices, int[] futurePrices, int pos, long money, int restDay ) {
    Order order = new Order(); 
    int prevPrice = getLatestPrice( spotPrices );
    int price1=0;
    int price2=0;
    
    int randomNumber=random.nextInt(2);
    if(randomNumber==0){
      order.buysell = order.BUY;
    }else if(randomNumber==1){
      order.buysell = order.SELL;
    }else{
      order.buysell = order.NONE;
    }

    while ( true ) {
      price1 = (int)(prevPrice *(1+0.05*random.nextGaussian()));
      if ( price1 > 0 ) break;
    }

    while ( true ) {
      price2 = (int)(prevPrice *(1+0.05*random.nextGaussian()));
      if ( price2 > 0 ) break;
    }
    
    
    order.quant=1;

    if(price1>price2){
      order.price = price1;
      order.buysell=order.SELL;
      orderRequest(order);

      order.price = price2;
      order.buysell=order.BUY;
      orderRequest(order);

    }else{
      order.price = price2;
      order.buysell=order.SELL;
      orderRequest(order);

      order.price = price1;
      order.buysell=order.BUY;
      orderRequest(order);
    }
  } // end of action
}
