/*
MarketMaker_RR
Copyright (c) 2004 NAKAJIMA Yoshihiro
̎sRandom Agent
*/

package strategy;
import java.util.*;
import java.io.*;

public class MarketMakerStrategy_RR extends Strategy {
  private Random random;
  
  /* Constructor for Agent Initialization */
  public MarketMakerStrategy_RR(int seed) {
    random = new Random(seed);
  }
  
  public void action( int[] spotPrices, int[] futurePrices, int pos, long money, int restDay ) {
      Order order = new Order();
    int prevPrice = getLatestPrice( spotPrices );
    int randomNumber=random.nextInt(20);
    if(randomNumber==0){
      order.buysell = order.BUY;
    }else if(randomNumber==1){
      order.buysell = order.SELL;
    }else{
      order.buysell = order.NONE;
    }
    while ( true ) {
      order.price = (int)(prevPrice *(1+0.05*random.nextGaussian()));
      if ( order.price > 0 ) break;
    }
    order.quant=5;
    orderRequest(order);
  } // end of action
}
